
	list	p=16F876
	#include P16F876.inc
	#include capa.inc
	#include macro.inc

	errorlevel -302


	extern	temp_1, temp_2, temp_3, temp_4


delay_code	CODE


;------------------ delay 100us --------------------------------
delay_100us
	GLOBAL	delay_100us
			;94 cycles
	movlw	0x1F
	movwf	temp_1
delay_100us_0
	decfsz	temp_1, f
	goto	delay_100us_0

			;2 cycles
	goto	$+1

			;4 cycles (including call)
	return


;------------------ delay 1ms --------------------------------
delay_1ms
	GLOBAL	delay_1ms
			;993 cycles
	movlw	0xC6
	movwf	temp_1
	movlw	0x01
	movwf	temp_2
delay_1ms_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	delay_1ms_0

			;3 cycles
	goto	$+1
	nop

			;4 cycles (including call)
	return

;------------------ delay 4ms --------------------------------
delay_4ms
	GLOBAL	delay_4ms
			;3993 cycles
	movlw	0x1E
	movwf	temp_1
	movlw	0x04
	movwf	temp_2
delay_4ms_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	delay_4ms_0

			;3 cycles
	goto	$+1
	nop

			;4 cycles (including call)
	return


;------------------ delay 10ms --------------------------------
delay_10ms
	GLOBAL	delay_10ms
			;9993 cycles
	movlw	0xCE
	movwf	temp_1
	movlw	0x08
	movwf	temp_2
delay_10ms_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	delay_10ms_0

			;3 cycles
	goto	$+1
	nop

			;4 cycles (including call)
	return


;------------------ delay 15ms --------------------------------
delay_15ms
	GLOBAL	delay_15ms
			;14993 cycles
	movlw	0xB6
	movwf	temp_1
	movlw	0x0C
	movwf	temp_2
delay_15ms_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	delay_15ms_0

			;3 cycles
	goto	$+1
	nop

			;4 cycles (including call)
	return

;------------------ delay 100ms --------------------------------
delay_100ms
	GLOBAL	delay_100ms
			;99993 cycles
	movlw	0x1E
	movwf	temp_1
	movlw	0x4F
	movwf	temp_2
delay_100ms_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	delay_100ms_0

			;3 cycles
	goto	$+1
	nop

			;4 cycles (including call)
	return


;------------------ delay 1s --------------------------------
delay_1s
	GLOBAL	delay_1s
			;999990 cycles
	movlw	0x07
	movwf	temp_1
	movlw	0x2F
	movwf	temp_2
	movlw	0x03
	movwf	temp_3
delay_1s_0
	decfsz	temp_1, f
	goto	$+2
	decfsz	temp_2, f
	goto	$+2
	decfsz	temp_3, f
	goto	delay_1s_0

			;6 cycles
	goto	$+1
	goto	$+1
	goto	$+1

			;4 cycles (including call)
	return


;------------------ delay 2s --------------------------------
delay_2s
	GLOBAL	delay_2s
	call	delay_1s
	call	delay_1s
	return

;------------------ delay 10s ------------------------------
delay_10s
	GLOBAL	delay_10s
	movlw	.10
	movwf	temp_4
delay_10s_0
	call	delay_1s
	decfsz	temp_4,f
	goto	delay_10s_0
	return

;------------------ delay 1min ------------------------------
delay_1min
	GLOBAL	delay_1min
	movlw	.60
	movwf	temp_4
delay_1min_0
	call	delay_1s
	decfsz	temp_4,f
	goto	delay_10s_0
	return


	END
